%% PREVIEW CONTROL DEMO
% Benjamin Stephens - 2009
% Robotics Institute, Carnegie Mellon University

clear all;clc
% close all;

figure(1);clf;

dx = 0.05;
dy = 0.05;
T = 0.05;
Tstep = 0.3;
Tdsp = 0.1;
L = 0.8;
g = 9.81;

%% initial condition

x0 = [0,0.3,0]';
y0 = [0,0.3,0]';
xf0 = 0;
yf0 = 0.12;
xs0 = 0;
ys0 = -0.12;
%%
TRAJ = [x0(1),y0(1),x0(2),y0(2),0,0];

% colors={'b','r','c','m','b','r','c','m'};

for i=1:10

% figure(1); subplot 121
% preview_step_withstart_opt;


X = [x0;xf0;y0;yf0;xs0;ys0];
[cost,step,traj] = preview_mex(X,L,T,1.0/T,Tstep,Tdsp);

if (Tstep+Tdsp)>0
    j = ceil((Tstep+Tdsp)/T)-1;
else
    j = 1.0/T;
end

traj = traj(:,1:j);

px=traj(1,:);
py=traj(2,:);
vx=traj(3,:);
vy=traj(4,:);
zx = px - 1.0/9.81*traj(5,:);
zy = py - 1.0/9.81*traj(6,:);
traj(5,:) = zx;
traj(6,:) = zy;
xf = step(1);
yf = step(2);

plot(px,py,'g--','LineWidth',2); hold on;
% plot(zx,zy,'b:','LineWidth',1);
plot(xf0,yf0,'m*');
plot(xf,yf,'m*');
plot(0.5*(xf0+xf),0.5*(yf0+yf),'m*','LineWidth',3,'MarkerSize',8);
h = plot([xf0-dx,xf0+dx,xf0+dx,xf0-dx,xf0-dx]',[yf0-dy,yf0-dy,yf0+dy,yf0+dy,yf0-dy]','b--',...
         [xs0-dx,xs0+dx,xs0+dx,xs0-dx,xs0-dx]',[ys0-dy,ys0-dy,ys0+dy,ys0+dy,ys0-dy]','k-');   
h = plot([xf-dx,xf+dx,xf+dx,xf-dx,xf-dx]',[yf-dy,yf-dy,yf+dy,yf+dy,yf-dy]','b--');
axis equal;


%%


x0 = [px(j),vx(j),0]';
y0 = [py(j),vy(j),0]';
xs0 = xf0;
ys0 = yf0;
xf0 = xf(1);
yf0 = yf(1);

TRAJ = [TRAJ;traj'];


plot(x0(1),y0(1),'kx','MarkerSize',8,'LineWidth',3);


% if abs(x0(1)-0.5*(xf0+xs0) + x0(2)*sqrt(L/g))<0.05 || (y0(1)-0.5*(yf0+ys0) + y0(2)*sqrt(L/g))<0.05
%     Tstep = 0.0;
%     Tdsp = 0.0;
% else
%     Tstep = 0.3;
%     Tdsp = 0.1;
% end

% pause;

end



figure(2);clf;
subplot 311
plot(TRAJ(:,1:2));
subplot 312
plot(TRAJ(:,3:4));
subplot 313
plot(TRAJ(:,5:6));


%%

% figure(1);
% for i=1:size(TRAJ,1)
%     h = plot(TRAJ(i,5),TRAJ(i,6),'bo');
%     pause(0.1);
%     delete(h);
% end
