%% Paramters
L = 1.0;
g=9.81;
% T = 0.05;  % timestep
% Tstep = 0.3;
% Tdsp = 0.1;
Nstep = floor(Tstep/T);
Ndsp = floor(Tdsp/T);

T2 = Tstep-Nstep*T;

dx = 0.05;
dy = 0.05;
vxmax = 0.5;
vymax = 0.5;

N = ceil(1.5/T)+1;

% step selection matrices
U = blkdiag(ones(Ndsp,1),ones(Nstep,1),ones(Ndsp,1),ones(N-2*Ndsp-Nstep,1));

dirx = sign(x0(1)-0.5*(xf0+xs0) + x0(2)*sqrt(L/g)+eps);
diry = sign(y0(1)-0.5*(yf0+ys0) + y0(2)*sqrt(L/g)+eps);

[dirx,diry]

% if (diry>=0)
%     xf0 = xr0;
%     yf0 = yr0;
%     xs0 = xl0;
%     ys0 = yl0; 
% else
%     xf0 = xl0;
%     yf0 = yl0;
%     xs0 = xr0;
%     ys0 = yr0;   
% end

%% Linear system lookahead
% x1 = A*x0 + B*u1
% x2 = A*x1 + B*u1 = A^2*x0 +   A*B*u0 +   B*u2
% x3 = A*x2 + B*u2 = A^3*x0 + A^2*B*u0 + A*B*u1 + B*u3
% ... iterate ...
% xN = ...         = A^N*x0 + A^(N-1)*B*u0 + ... + B*uN

A = [1,T,T*T*0.5;
     0,1,T;
     0,0,1];
B = [T*T*T/6;T*T/2;T];

% A2 = [1,T2,T2*T2*0.5;
%      0,1,T2;
%      0,0,1];
% B2 = [T2*T2*T2/6;T2*T2/2;T2];
% 
% T3 = T-T2;
% A3 = [1,T3,T3*T3*0.5;
%      0,1,T3;
%      0,0,1];
% B3 = [T3*T3*T3/6;T3*T3/2;T3];

C = [1,0,-L/g];

P = [A,B,zeros(3,N-1)];
CC = C*P;

for i=1:N-1
%     if (i==Nstep)        
%         Pi = [A2*P(end-2:end,1:3+i),B2,zeros(3,N-1-i)];
%     elseif (i==Nstep+1)
%         Pi = [A3*P(end-2:end,1:3+i),B3,zeros(3,N-1-i)];
%     else
        Pi = [A*P(end-2:end,1:3+i),B,zeros(3,N-1-i)];
%     end
    P = [P;Pi];  
    CC = [CC;C*Pi];

end

% positions
Ppx = P(1:3:end,1:3);
Ppu = P(1:3:end,4:end);
% velocities
Pvx = P(2:3:end,1:3);
Pvu = P(2:3:end,4:end);
% accelerations
Pax = P(3:3:end,1:3);
Pau = P(3:3:end,4:end);
% zmp
Pzx = CC(:,1:3);
Pzu = CC(:,4:end);



%% Use the symbolic math toolbox to derive the math:
% clear all;clc;
% syms a b c d e u U0 U1 U2 UN Xs0 Xf0 Xf DF Pzu Pzx Ppu Ppx Pvx Pvu x0 real;
% Z = Pzx*x0 + Pzu*u;
% P = Ppx*x0 + Ppu*u;
% V = Pvx*x0 + Pvu*u;
% % A = Pax*x0 + Pau*u;
% Zref = U0*0.5*(Xf0+Xs0) + U1*Xf0 + U2*0.5*(Xf0+Xf);
% Pref = UN*0.5*(Xf0+Xf);
% 
% Xf_d = Xf0 + DF;
% 
% 
% J = 0.5*b*(Pref-P)'*(Pref-P) + 0.5*c*V'*V + 0.5*d*u'*u + 0.5*e*(Xf_d-Xf)'*(Xf_d-Xf);
% 
% dJ = jacobian(J,[u,Xf]);
% 
% H = jacobian(dJ,[u,Xf])
% 
% f = subs(dJ,[u,Xf],[0,0])


%%
UN = ones(N,1);
U0 = U(:,1);U1 = U(:,2);U2 = U(:,3);U3 = U(:,4);

a = 1e-5;
b = 0.1;
c = 0.01;
d = 1e-5;
e = 6e-0;


% H =... 
% [         a*Pzu'*Pzu+b*Ppu'*Ppu+c*Pvu'*Pvu+d*eye(N), -1/2*a*Pzu'*U2-1/2*b*Ppu'*UN;
%          -1/2*a*U2'*Pzu-1/2*b*UN'*Ppu,    1/4*a*U2'*U2+1/4*b*UN'*UN+e];
% 
% p = @(Xf0,Xs0,DF)...
%  [                 -a*(1/2*U0*(Xf0+Xs0)+U1*Xf0+1/2*U2*Xf0-Pzx*x0)'*Pzu-b*(1/2*UN*Xf0-Ppx*x0)'*Ppu+c*(Pvx*x0)'*Pvu,...
%     1/2*a*(1/2*U0*(Xf0+Xs0)+U1*Xf0+1/2*U2*Xf0-Pzx*x0)'*U2+1/2*b*(1/2*UN*Xf0-Ppx*x0)'*UN-e*(Xf0+DF)];
H =... 
[    b*Ppu'*Ppu+c*Pvu'*Pvu+d*eye(N), -1/2*b*Ppu'*UN;
     -1/2*b*UN'*Ppu,                 1/4*b*UN'*UN+e];

p = @(x0,Xf0,Xs0,DF)...
 [  -b*(1/2*UN*Xf0-Ppx*x0)'*Ppu+c*(Pvx*x0)'*Pvu,...
 1/2*b*(1/2*UN*Xf0-Ppx*x0)'*UN-e*(Xf0+DF)];

%
  
Q = blkdiag(H,H); % for 3D

f = [p(x0,xf0,xs0,0),p(y0,yf0,ys0,0.24*sign(ys0-yf0))];

%% optimal controller

% this is the unconstrained solution
u0 = -Q\f';

%% ZMP constraints
% NOTE: constrained solution can be found with quadprog with inequality
% constraints on the location of the ZMP, 
% if z = Pzx*x0 + Pzu*u
% ans xf = Uc*xfc0 + U*Xf
% and xf - a < z < xf + b
% then
% -Pzu*u + U*Xf <  Pzx*x0 - Uc*xfc0 + a
%  Pzu*u - U*Xf < -Pzx*x0 + Uc*xfc0 + b
% .. which can be re-written as A*u<b as needed for quadprog
%
% Currently the constraints in double support are a box with the edges
% associated with the min/max edges of the support polygon.  This is not a
% conservative approximation, but it's better than nothing :).
%
ax = dx;
bx = dx;
ay = dy;
by = dy;

% if (dirx>0)
%   U0*(min(xf0,xs0) - a) + U1*(xf0 - a) + U2*(xf0 - a) < Pzx*x0 + Pzu*ux < U0*(max(xf0,xs0) + b) U1*(xf0 + b) + U2*(xf + b);
%     Ax = [-Pzu,zeros(N,1);
%            Pzu,-U2];
%     bx = [ Pzx*x0 - U0*(min(xf0,xs0) - ax) - (U1+U2)*(xf0 - ax);
%           -Pzx*x0 + U0*(max(xf0,xs0) + bx) + U1*(xf0 + bx) + U2*bx];  

%   U0*(min(xf0,xs0) - a) + U1*(xf0 - a) + U2*(xf - a) < Pzx*x0 + Pzu*ux < U0*(max(xf0,xs0) + b) U1*(xf0 + b) + U2*(xf + b);
    Ax = [-Pzu, U2;
           Pzu,-U2-U3];
    bx = [ Pzx*x0 - U0*(min(xf0,xs0) - ax) - U1*(xf0 - ax) - U2*(-ax) - U3*(xf0 - ax);
          -Pzx*x0 + U0*(max(xf0,xs0) + bx) + U1*(xf0 + bx) + U2*bx + U3*bx];      
      
% else    
% %   U0*(min(xf0,xs0) - a) + U1*(xf0 - a) + U2*(xf0 - a) < Pzx*x0 + Pzu*ux < U0*(max(xf0,xs0) + b) U1*(xf0 + b) + U2*(xf + b);
%     Ax = [-Pzu,U2;
%            Pzu,zeros(N,1)];
%     bx = [ Pzx*x0 - U0*(min(xf0,xs0) - ax) - U1*(xf0 - ax) + U2*ax;
%           -Pzx*x0 + U0*(max(xf0,xs0) + bx) + UN*(xf0 + bx)];        
% end

% 
% if (ys0>yf0)
% %     U0*(min(yf0,ys0) - a) + U1*(yf0 - a) + U2*(yf0 - a) < Pzx*y0 + Pzu*uy < U0*(max(yf0,ys0) + b) U1*(yf0 + b) + U2*(yf + b);
%     Ay = [-Pzu,zeros(N,1);
%            Pzu,-U2];
%     by = [ Pzx*y0 - U0*(min(yf0,ys0) - ay) - (U1+U2)*(yf0 - ay);
%           -Pzx*y0 + U0*(max(yf0,ys0) + by) + U1*(yf0 + by) + U2*by];  
% else    
% %     U0*(min(yf0,ys0) - a) + U1*(yf0 - a) + U2*(yf - a) < Pzx*y0 + Pzu*uy < U0*(max(yf0,ys0) + b) U1*(yf0 + b) + U2*(yf0 + b);
%     Ay = [-Pzu,U2;
%            Pzu,zeros(N,1)];
%     by = [ Pzx*y0 - U0*(min(yf0,ys0) - ay) - U1*(yf0 - ay) + U2*ay;
%           -Pzx*y0 + U0*(max(yf0,ys0) + by) + (U1+U2)*(yf0 + by)];   
% end

if (ys0>yf0)
%     U0*(min(yf0,ys0) - a) + U1*(yf0 - a) + U2*(yf - a) + U3*(yf0 - a) < Pzx*y0 + Pzu*uy < U0*(max(yf0,ys0) + b) U1*(yf0 + b) + U2*(yf + b) + U3*(yf + b);
    Ay = [-Pzu,U2;
           Pzu,-U2-U3];
    by = [ Pzx*y0 - U0*(min(yf0,ys0) - ay) - U1*(yf0 - ay) - U2*(-ay) - U3*(yf0-ay);
          -Pzx*y0 + U0*(max(yf0,ys0) + by) + U1*(yf0 + by) + U2*( by) + U3*( by)];  
else    
%     U0*(min(yf0,ys0) - a) + U1*(yf0 - a) + U2*(yf - a) + U3*(yf - a) < Pzx*y0 + Pzu*uy < U0*(max(yf0,ys0) + b) U1*(yf0 + b) + U2*(yf + b) + U3*(yf0 + b);
    Ay = [-Pzu,U2+U3;
           Pzu,-U2];
    by = [ Pzx*y0 - U0*(min(yf0,ys0) - ay) - U1*(yf0 - ay) - U2*(-ay) - U3*(-ay) ;
          -Pzx*y0 + U0*(max(yf0,ys0) + by) + U1*(yf0 + by) + U2*( by) + U3*(yf0+by)];   
end


% foot velocity constraints
Ax = [Ax;zeros(1,N),1;zeros(1,N),-1];
bx = [bx;xs0+Tstep*vxmax;-xs0+Tstep*vxmax];
Ay = [Ay;zeros(1,N),1;zeros(1,N),-1];
by = [by;ys0+Tstep*vymax;-ys0+Tstep*vymax];
   
A = blkdiag(Ax,Ay);
b = [bx;by];

% double support constraints
% M = ceil(Tdsp/T)-1;
% v0 = [xs0-xf0,ys0-yf0];
% p1 = [sign(v0(2)+eps)*0.05,yf0-sign(v0(1)+eps)*0.05];
% p2 = [-p1(1),yf0 + sign(v0(1)+eps)*0.05];
% [p1,p2]
% A = [A;[ v0(2)*Pzu(1:M,:),zeros(M,1),-v0(1)*Pzu(1:M,:),zeros(M,1);
%         -v0(2)*Pzu(1:M,:),zeros(M,1), v0(1)*Pzu(1:M,:),zeros(M,1)]];
% b = [b;[-v0(2)*(Pzx(1:M,:)*x0-p1(1))+v0(1)*(Pzx(1:M,:)*y0-p1(2));
%          v0(2)*(Pzx(1:M,:)*x0-p2(1))-v0(1)*(Pzx(1:M,:)*y0-p2(2))]];

%%
% size(A)
[u1,fval,exitflag] = quadprog(Q,f,A,b,[],[],[],[],u0);    
[fval,exitflag]


%%
uxy = reshape(u1,N+1,2);

ux = uxy(1:N,1);
uy = uxy(1:N,2);

xf = uxy(N+1:end,1);
yf = uxy(N+1:end,2);
% [xf,yf]
dp = [xf-xf0;yf-yf0];

px = Ppx*x0 + Ppu*ux;
py = Ppx*y0 + Ppu*uy;
vx = Pvx*x0 + Pvu*ux;
vy = Pvx*y0 + Pvu*uy;
zx = Pzx*x0 + Pzu*ux;
zy = Pzx*y0 + Pzu*uy;

% zxref = Uc*xf0 + 0.5*U*(xf0+xf);
% zyref = Uc*yf0 + 0.5*U*(yf0+yf);

% time = T:T:N*T;
% 
% % figure(1);
% 
% plot(px,py,'g--','LineWidth',2); hold on;
% plot(zx,zy,'b--','LineWidth',2);
% % plot(zxref,zyref,'k--');
% plot(xf0,yf0,'m*');
% plot(xf,yf,'m*');
% plot(0.5*(xf0+xf),0.5*(yf0+yf),'m*','LineWidth',3);
% % plot([xf0;xf0+0.2*(x0(1)-xf0+x0(2)*sqrt(L/g))],[yf0;yf0+0.2*(y0(1)-yf0+y0(2)*sqrt(L/g))],'m-'); 
% 
% h = plot([xf0-dx,xf0+dx,xf0+dx,xf0-dx,xf0-dx]',[yf0-dy,yf0-dy,yf0+dy,yf0+dy,yf0-dy]','k-',...
%          [xs0-dx,xs0+dx,xs0+dx,xs0-dx,xs0-dx]',[ys0-dy,ys0-dy,ys0+dy,ys0+dy,ys0-dy]','k--');
%      
% % uxy0 = reshape(u0,N+1,2);
% % xfu = uxy0(N+1:end,1);
% % yfu = uxy0(N+1:end,2);     
% % h = plot([xfu-dx,xfu+dx,xfu+dx,xfu-dx,xfu-dx]',[yfu-dy,yfu-dy,yfu+dy,yfu+dy,yfu-dy]','m:');
% 
% uxy1 = reshape(u1,N+1,2);
% xfu = uxy1(N+1:end,1);
% yfu = uxy1(N+1:end,2);     
% h = plot([xfu-dx,xfu+dx,xfu+dx,xfu-dx,xfu-dx]',[yfu-dy,yfu-dy,yfu+dy,yfu+dy,yfu-dy]','m--');
% 
% axis equal;