L = 1.0;
g=9.81;

Nstep = floor(Tstep/T);
Ndsp = floor(Tdsp/T);

% T2 = Tstep-Nstep*T;

dx = 0.06;
dy = 0.04;

N = ceil(1.5/T)+1;

M = 3;

% step selection matrices
U = blkdiag(ones(Ndsp,1),ones(Nstep,1),ones(Ndsp,1),ones(Nstep,1),ones(Ndsp,1),ones(Nstep,1),ones(N-M*Nstep-M*Ndsp,1));
UF = [zeros(N-1,1);1];

% Uc = [ones(Nstep,1);zeros(N-Nstep,1)];
% U = [zeros(Nstep,1);ones(N-Nstep,1)];

%% initial condition

vxmax = 2.0;
vymax = 2.0;

% ZMP double support box constraints
% dirx = sign(x0(1)-0.5*(xl0+xr0) + x0(2)*sqrt(L/g)+eps);
% diry = sign(y0(1)-0.5*(yl0+yr0) + y0(2)*sqrt(L/g)+eps);
% 
% [dirx,diry]

% if (diry>0)
%     xf0 = xr0;
%     yf0 = yr0;
%     xs0 = xl0;
%     ys0 = yl0; 
% else
%     xf0 = xl0;
%     yf0 = yl0;
%     xs0 = xr0;
%     ys0 = yr0;   
% end


%% Linear system lookahead
% x1 = A*x0 + B*u1
% x2 = A*x1 + B*u1 = A^2*x0 +   A*B*u0 +   B*u2
% x3 = A*x2 + B*u2 = A^3*x0 + A^2*B*u0 + A*B*u1 + B*u3
% ... iterate ...
% xN = ...         = A^N*x0 + A^(N-1)*B*u0 + ... + B*uN

A = [1,T,T*T*0.5;
     0,1,T;
     0,0,1];
B = [T*T*T/6;T*T/2;T];

% A2 = [1,T2,T2*T2*0.5;
%      0,1,T2;
%      0,0,1];
% B2 = [T2*T2*T2/6;T2*T2/2;T2];
% 
% T3 = T-T2;
% A3 = [1,T3,T3*T3*0.5;
%      0,1,T3;
%      0,0,1];
% B3 = [T3*T3*T3/6;T3*T3/2;T3];

C = [1,0,-L/g];

P = [A,B,zeros(3,N-1)];
CC = C*P;

for i=1:N-1
%     if (i==Nstep)        
%         Pi = [A2*P(end-2:end,1:3+i),B2,zeros(3,N-1-i)];
%     elseif (i==Nstep+1)
%         Pi = [A3*P(end-2:end,1:3+i),B3,zeros(3,N-1-i)];
%     else
        Pi = [A*P(end-2:end,1:3+i),B,zeros(3,N-1-i)];
%     end
    P = [P;Pi];  
    CC = [CC;C*Pi];

end

% positions
Ppx = P(1:3:end,1:3);
Ppu = P(1:3:end,4:end);
% velocities
Pvx = P(2:3:end,1:3);
Pvu = P(2:3:end,4:end);
% accelerations
Pax = P(3:3:end,1:3);
Pau = P(3:3:end,4:end);
% zmp
Pzx = CC(:,1:3);
Pzu = CC(:,4:end);

% Pzx


%% Use the symbolic math toolbox to derive the math:
% clear all;clc
% syms a b c d e U0 U1 U2 U3 U4 U5 U6 UN UF Xf0 Xf1 Xf2 Xf3 Xf4 DF1 DF2 DF3 Pzu Pzx Ppu Ppx Pvx Pvu u x0 real;
% Z = Pzx*x0 + Pzu*u;
% P = Ppx*x0 + Ppu*u;
% V = Pvx*x0 + Pvu*u;
% % A = Pax*x0 + Pau*u;
% Zref = U0*0.5*(Xf0+Xf1) + U1*Xf1 + (U2+U3)*Xf2 + (U4+U5)*Xf2 + U6*0.5*(Xf2+Xf3);
% Pref = UN*0.5*(Xf3+Xf4);
% Xf2_d = Xf1 + DF1;
% Xf3_d = Xf2 + DF2;
% Xf4_d = Xf3 + DF3;
% 
% PrefF = 0.5*(Xf3+Xf4);
% 
% % J1 = 0*0.5*a*(Zref-Z)'*(Zref-Z); 
% J1 = 0.5*b*(Pref-P)'*(Pref-P);% + 0.5*10*b*(Pref-P)'*UF*UF'*(Pref-P); 
% J2 = 0.5*c*V'*V + 0.5*d*u'*u;% + 0.5*10*c*V'*UF*UF'*V; 
% J3 = 0.5*e*(Xf2_d-Xf2)'*(Xf2_d-Xf2); 
% J4 = 0.5*e*(Xf3_d-Xf3)'*(Xf3_d-Xf3);
% J5 = 0.5*e*(Xf4_d-Xf4)'*(Xf4_d-Xf4);
% J = J1+J2+J3+J4+J5;
% 
% z = [u,Xf2,Xf3,Xf4];
% 
% dJ1 = jacobian(J1,z);
% dJ2 = jacobian(J2,z);
% dJ3 = jacobian(J3,z);
% dJ4 = jacobian(J4,z);
% dJ5 = jacobian(J5,z);
% 
% H1 = jacobian(dJ1,z);
% H2 = jacobian(dJ2,z);
% H3 = jacobian(dJ3,z);
% H4 = jacobian(dJ4,z);
% H5 = jacobian(dJ5,z);
% 
% H = H1 + H2 + H3 + H4 + H5
% 
% f = subs(jacobian(J,z),z,0*z)


%%
UN = ones(N,1);

% % a = 1e-4;
% b = 1.0e-1;
% c = 0.1;
% d = 1e-4;
% e = 100.0e-0;

U0 = U(:,1);U1 = U(:,2);U2 = U(:,3);U3 = U(:,4);U4 = U(:,5); U5 = U(:,6); U6 = U(:,7);

% H = ...
% [ a*Pzu'*Pzu+b*Ppu'*Ppu+c*Pvu'*Pvu+d,  -a*Pzu'*(U2+U3),        -a*Pzu'*U4-b*Ppu'*UN;
%             -a*(U2+U3)'*Pzu,           a*(U2+U3)'*(U2+U3)+2*e,      a*(U2+U3)'*U4-e;
%         -a*U4'*Pzu-b*UN'*Ppu,            a*(U2+U3)'*U4-e,           a*U4'*U4+b*UN'*UN+e];
% H = ...
% [    a*Pzu'*Pzu+b*Ppu'*Ppu+c*Pvu'*Pvu+d*eye(N), -a*Pzu'*(U2+U3+1/2*U4)-1/2*b*Ppu'*UN,              -1/2*a*Pzu'*U4-1/2*b*Ppu'*UN;
%     -a*(U2+U3+1/2*U4)'*Pzu-1/2*b*UN'*Ppu,        a*(U2+U3+1/2*U4)'*(U2+U3+1/2*U4)+1/4*b*UN'*UN+2*e, 1/2*a*(U2+U3+1/2*U4)'*U4+1/4*b*UN'*UN-e;
%     -1/2*a*U4'*Pzu-1/2*b*UN'*Ppu,                1/2*a*U4'*(U2+U3+1/2*U4)+1/4*b*UN'*UN-e,           1/4*a*U4'*U4+1/4*b*UN'*UN+e];
H = ...
[ b*Ppu'*Ppu+c*Pvu'*Pvu+d*eye(N),   zeros(N,1),    -1/2*b*Ppu'*UN,     -1/2*b*Ppu'*UN;
      zeros(1,N),                   2*e,           -e,                   0;
     -1/2*b*UN'*Ppu,                -e,           1/4*b*N+2*e,           1/4*b*N-e;
     -1/2*b*UN'*Ppu,                0,            1/4*b*N-e,             1/4*b*N+e];

p = @(x0,Xf0,Xf1,DF1,DF2,DF3) ...
[   b*(Ppx*x0)'*Ppu+c*(Pvx*x0)'*Pvu,...    
-e*(Xf1+DF1)+e*DF2,...    
-1/2*b*(Ppx*x0)'*UN-e*DF2+e*DF3,...    
-1/2*b*(Ppx*x0)'*UN-e*DF3]; 
% [   -a*(1/2*U0*(Xf0+Xf1)+U1*Xf1-Pzx*x0)'*Pzu+b*(Ppx*x0)'*Ppu+c*(Pvx*x0)'*Pvu,...      
%      a*(1/2*U0*(Xf0+Xf1)+U1*Xf1-Pzx*x0)'*(U2+U3)-e*(Xf1+DF1)+e*DF2,...           
%      a*(1/2*U0*(Xf0+Xf1)+U1*Xf1-Pzx*x0)'*U4-b*(Ppx*x0)'*UN-e*DF2];

fx = p(x0,xs0,xf0,0,0,0);
fy = p(y0,ys0,yf0,sign(ys0-yf0)*0.24,-sign(ys0-yf0)*0.24,sign(ys0-yf0)*0.24);

f = [fx,fy];

% f
  
Q = blkdiag(H,H); % for 3D   

%% optimal controller


u0 = -Q\f';

%% ZMP constraints

%
ax = dx;
bx = dx;

ay = dy;
by = dy;

% U0*(0.5*(xs0+xf0)-a) + U1*(xf0-a) + (U2+U3)*(xf2-a) + (U4+U5)*(xf3-a) +  U6*(0.5*(xf3+xf4)-a) < Pzx*x0 + Pzu*ux < U0*(0.5*(xs0+xf0)+b) + U1*(xf0+b) + (U2+U3)*(xf2+b) + (U4+U5)*(xf3+b) + U6*(0.5*(xf3+xf4)+b)
Ax = [-Pzu, U2+U3, U4+U5+0.5*U6, U6*0.5;
       Pzu,-U2-U3,-U4-U5-0.5*U6,-U6*0.5];
bx = [ Pzx*x0 - U0*(min(xf0,xs0)-ax) - U1*(xf0-ax) - (U2+U3)*(   -ax) - (U4+U5)*(   -ax) - U6*(   -ax);
      -Pzx*x0 + U0*(max(xf0,xs0)+bx) + U1*(xf0+bx) + (U2+U3)*(   +bx) + (U4+U5)*(   +bx) + U6*(   +bx)];
  
Ay = [-Pzu, U2+U3, U4+U5+0.5*U6, U6*0.5;
       Pzu,-U2-U3,-U4-U5-0.5*U6,-U6*0.5];
by = [ Pzx*y0 - U0*(min(yf0,ys0)-ay) - U1*(yf0-ay) - (U2+U3)*(   -ay) - (U4+U5)*(   -ay) - U6*(   -ay);
      -Pzx*y0 + U0*(max(yf0,ys0)+by) + U1*(yf0+by) + (U2+U3)*(   +by) + (U4+U5)*(   +by) + U6*(   +by)];


% % foot distance constraints
Ax = [Ax;zeros(1,N), 1, 0, 0;
         zeros(1,N),-1, 0, 0;
         zeros(1,N),-1, 1, 0;
         zeros(1,N), 1,-1, 0;
         zeros(1,N), 0,-1, 1;
         zeros(1,N), 0, 1,-1];
bx = [bx; xf0+0.3;
         -xf0+0.3;
             +0.3;
             +0.3
             +0.3
             +0.3];
Ay = [Ay;zeros(1,N), 1, 0, 0;
         zeros(1,N),-1, 0, 0;
         zeros(1,N),-1, 1, 0;
         zeros(1,N), 1,-1, 0;
         zeros(1,N), 0,-1, 1;
         zeros(1,N), 0, 1,-1];
by = [by; yf0+0.3;
         -yf0+0.3;
             +0.3;
             +0.3
             +0.3
             +0.3];



% % % foot velocity constraints
% Ax = [Ax;zeros(1,N),1,0;
%         zeros(1,N),-1,0;];
% %         zeros(1,N),0,1;
% %         zeros(1,N),0,-1];
% bx = [bx;xs0+Tstep*vxmax;
%         -xs0+Tstep*vxmax;];
% %          xf0+Tstep*vxmax;
% %         -xf0+Tstep*vxmax;];
% Ay = [Ay;zeros(1,N),1,0;
%         zeros(1,N),-1,0;];
% %         zeros(1,N),0,1;
% %         zeros(1,N),0,-1];
% by = [by;ys0+Tstep*vymax;
%         -ys0+Tstep*vymax;];
% %          yf0+Tstep*vymax;
% %         -yf0+Tstep*vymax;];
   
AA = blkdiag(Ax,Ay);
bb = [bx;by];

%%
% size(A)
[u1,fval,exitflag] = quadprog(Q,f,AA,bb,[],[],[],[],u0);    
[fval,exitflag]


%%
uxy = reshape(u1,N+3,2);

ux = uxy(1:N,1);
uy = uxy(1:N,2);

xf = uxy(N+1:end,1);
yf = uxy(N+1:end,2);
% [xf,yf]
% dp = [xf-xf0;yf-yf0];

px = Ppx*x0 + Ppu*ux;
py = Ppx*y0 + Ppu*uy;
vx = Pvx*x0 + Pvu*ux;
vy = Pvx*y0 + Pvu*uy;

zx = Pzx*x0 + Pzu*ux;
zy = Pzx*y0 + Pzu*uy;

% zxref = Uc*xf0 + 0.5*U*(xf0+xf);
% zyref = Uc*yf0 + 0.5*U*(yf0+yf);

time = T:T:N*T;

